// Generated by CoffeeScript 1.7.1
(function() {
  var Org,
    __slice = [].slice;

  Org = (function() {
    function Org(name, client) {
      this.name = name;
      this.client = client;
    }

    Org.prototype.info = function(cb) {
      return this.client.get("/orgs/" + this.name, function(err, s, b, h) {
        if (err) {
          return cb(err);
        }
        if (s !== 200) {
          return cb(new Error('Org info error'));
        } else {
          return cb(null, b, h);
        }
      });
    };

    Org.prototype.update = function(info, cb) {
      return this.client.post("/orgs/" + this.name, info, function(err, s, b, h) {
        if (err) {
          return cb(err);
        }
        if (s !== 200) {
          return cb(new Error('Org update error'));
        } else {
          return cb(null, b, h);
        }
      });
    };

    Org.prototype.repo = function(nameOrRepo, cb) {
      if (typeof cb === 'function' && typeof nameOrRepo === 'object') {
        return this.createRepo(nameOrRepo, cb);
      } else {
        return this.client.repo("" + this.name + "/" + nameOrRepo);
      }
    };

    Org.prototype.repos = function() {
      var cb, params, _i, _ref;
      params = 2 <= arguments.length ? __slice.call(arguments, 0, _i = arguments.length - 1) : (_i = 0, []), cb = arguments[_i++];
      return (_ref = this.client).get.apply(_ref, ["/orgs/" + this.name + "/repos"].concat(__slice.call(params), [function(err, s, b, h) {
        if (err) {
          return cb(err);
        }
        if (s !== 200) {
          return cb(new Error('Org repos error'));
        } else {
          return cb(null, b, h);
        }
      }]));
    };

    Org.prototype.createRepo = function(repo, cb) {
      return this.client.post("/orgs/" + this.name + "/repos", repo, function(err, s, b, h) {
        if (err) {
          return cb(err);
        }
        if (s !== 201) {
          return cb(new Error('Org createRepo error'));
        } else {
          return cb(null, b, h);
        }
      });
    };

    Org.prototype.teams = function(cb) {
      return this.client.get("/orgs/" + this.name + "/teams", function(err, s, b, h) {
        if (err) {
          return cb(err);
        }
        if (s !== 200) {
          return cb(new Error('Org teams error'));
        } else {
          return cb(null, b, h);
        }
      });
    };

    Org.prototype.members = function(cb) {
      return this.client.get("/orgs/" + this.name + "/members", function(err, s, b, h) {
        if (err) {
          return cb(err);
        }
        if (s !== 200) {
          return cb(new Error('Org members error'));
        } else {
          return cb(null, b, h);
        }
      });
    };

    Org.prototype.member = function(user, cb) {
      return this.client.getNoFollow("/orgs/" + this.name + "/members/" + user, function(err, s, b, h) {
        if (err) {
          return cb(err);
        }
        return cb(null, s === 204, h);
      });
    };

    Org.prototype.createTeam = function(options, cb) {
      return this.client.post("/orgs/" + this.name + "/teams", options, function(err, s, b, h) {
        if (err) {
          return cb(err);
        }
        if (s !== 200) {
          return cb(new Error('Org createTeam error'));
        } else {
          return cb(null, b, h);
        }
      });
    };

    return Org;

  })();

  module.exports = Org;

}).call(this);
